/* obliczanie e z dowolna pracyzja. gmp required.
 * (c) (GPL) Michal Moskal <malekith@pld.org.pl>
 */
#include <stdio.h>
#include <gmp.h>

#define PREC 10000
#define N 1000		/* n = 1 << N */

int main()
{
	int i;
	mpf_t x, y;

	mpf_init2(x, PREC);
	mpf_init2(y, PREC);
	
	mpf_set_ui(x, 1);		/* x = 1 */
	mpf_set_ui(y, 1);		/* y = 1 */
	mpf_mul_2exp(y, y, N);		/* y = n */
	mpf_div(x, x, y);		/* x = 1 / n */
	mpf_set_ui(y, 1);		/* y = 1 */
	mpf_add(x, y, x);		/* x = 1 + 1 / n */

	printf("n = 2 ^ %d, prec = %d\n", N, PREC);
	printf("1 + 1/n = ");
	mpf_out_str(stdout, 10, 0, x);
	printf("\n");
	for (i = 0; i < N; i++) 
		mpf_mul(x, x, x);

	printf("(1 + 1/n) ^ n = ");
	mpf_out_str(stdout, 10, 0, x);
	printf("\n");

	return 0;
}
