/*
obliczanie pi ze wzoru

arctg(x) = y
              3       5         7
           1*x   1*3*x   1*3*5*x
   y = x + --- + ----- + ------- + .....
           2*3   2*4*5   2*4*6*7
(C) GPL Michal Moskal <malekith@pld.org.pl>
*/
/*
main()
{
	long double up = 1, down = 1;
	long double n = 1;
	long double pi = 0;
	int k = 1000;

	while (k--) {
		pi += up / down;
		down /= n;
		up *= n;
		n += 2;
		down *= n - 1;
		down *= n;
	}

	pi *= 2

	printf("pi = %Lf\n", pi);
}
*/
#include <stdio.h>
#include <gmp.h>

int main(int argc, char **argv)
{
	mpf_t up, down, pi, tmp,x,xx;
	int k = 1000,kk = 1000,m=2;
	int start;
	int n;
	
	if (--argc) {
		kk = k = atoi(*++argv);
		if(--argc)m=atoi(*++argv);
	}
	
	k *= m;

start = time(0);
	mpf_set_default_prec(kk * 4);
	mpf_init_set_si(up, 1);
	mpf_init_set_si(down, 1);
	mpf_init_set_si(pi, 0);
	mpf_init_set_d(x, 0.5);
	mpf_init_set_d(xx, 0.25);
	mpf_init(tmp);
	n = 1;
	
	while (k--) {
		fprintf(stderr,"\r%d left",k);
		/* pi += up / down; */
		mpf_div(tmp,up,down);
		mpf_mul(tmp,tmp,x);
		mpf_mul(x,x,xx);
		mpf_add(pi,pi,tmp);
		/* down /= n; */
		mpf_div_ui(down,down,n);
		/* up *= n; */
		mpf_mul_ui(up,up,n);
		n++;
		/* down *= n; */
		mpf_mul_ui(down,down,n);
		n++;
		/* down *= n; */
		mpf_mul_ui(down,down,n);
	}

	/* pi *= 6; */
	mpf_mul_ui(pi, pi, 6);

{
FILE *f;
f=fopen("pi.out","a");
fprintf(f,"for %d digits (m = %d), after %d secs\n",kk,m,time(0)-start);
mpf_out_str(f,10 , kk, pi);
fprintf(f,"\n-----------------------\n\n");
fclose(f);
}
	
	return 0;
}
